      function InitSeries(SeriesCount,Options) {
        var series=[[]];
        for (i=1;i<SeriesCount;i++) {
          series.push([]);
          Options.series.push({lineWidth:1,showMarker:false,showLine:true});
        }
        return series;
      }

      // With default setting this chart has time on x-axis. 
      function AutoScrollingLineChart(Title,DivIDName,SeriesCount) {
        this.DivIDName=DivIDName;
        this.Chart;
        this.DefXScale=120000; // Full scale for time axis. 2 min * 60 * 1000
        this.DefSmallMove=90000;  // Small move for time axis. 1.5 min *60 *1000
        this.DefXScaleRound=30000; // Time axis min/max round value. 10 s * 1000
        this.DefXScaleAutoScrollSize=30000; // How much time scale jumps on auto scroll. 20 s * 1000
        this.MaxPointsCount=100000;
        this.MaxZoom=2;
        this.XScale=this.DefXScale;
        this.SmallMove=this.DefSmallMove;
        this.XScaleRound=this.DefXScaleRound;
        this.XScaleAutoScrollSize=this.DefXScaleAutoScrollSize;
        this.ZoomFactor=1;
        this.XMax=(new Date()).getTime();
        this.AutoScroll=true;
        this.ChartOptions = {      
                title:Title, 
                series:[
                    {
                      lineWidth:1,
                      showMarker:false,
                      showLine:true
                    }
                ], 
                axes: {   	    
                  xaxis: {   	   	   
                    numberTicks: 5,            
                    renderer:$.jqplot.DateAxisRenderer,           
                    tickOptions:{formatString:'%H:%M:%S'},            
                    min: 0,
                    max: 0   
                  }, 	    
                  yaxis: {
                    min:0, 
          //          max: 6,
                    numberTicks: 6,   	        
                    tickOptions:{formatString:'%.1f'}  	    
          //        },
          //        y2axis:{
          //            min:0, 
          //            max:360, 
          //            numberTicks:9, 
          //            tickOptions:{showGridline:false}
                  } 
                },      
                axesDefaults:{useSeriesColor: true}, 
                seriesDefaults: {
//                  showMarker:false,
                  rendererOptions: { smooth: true}      
                }  
              };  
        this.Series=InitSeries(SeriesCount,this.ChartOptions);
      }
      
      AutoScrollingLineChart.prototype.SetYMinMax=function(min,max,numberTicks) {
        this.ChartOptions.axes.yaxis.min=min;
        this.ChartOptions.axes.yaxis.max=max;
        this.ChartOptions.axes.yaxis.numberTicks=numberTicks;
      }
      
      AutoScrollingLineChart.prototype.SetYRoundedMinMaxTickDist=function(min,max,TickDist) {
        this.ChartOptions.axes.yaxis.min=Math.ceil((min-TickDist*0.99)/TickDist)*TickDist;
        this.ChartOptions.axes.yaxis.max=Math.ceil(max/TickDist)*TickDist;
        var tickCount=Math.round((this.ChartOptions.axes.yaxis.max-this.ChartOptions.axes.yaxis.min)/TickDist)+1;
        this.ChartOptions.axes.yaxis.numberTicks=tickCount;
      }
      
      AutoScrollingLineChart.prototype.SetSeriesSecondaryAxis=function(SeriesID,min,max,numberTicks) {
        this.ChartOptions.series[SeriesID].yaxis='y2axis';
        this.ChartOptions.axes.y2axis={tickOptions:{showGridline:false}};
        this.ChartOptions.axes.y2axis.min=min;
        this.ChartOptions.axes.y2axis.max=max;
        this.ChartOptions.axes.y2axis.numberTicks=numberTicks;
      }
      
      AutoScrollingLineChart.prototype.AddNoDrawData = function(x,y) {
        this.Series[0].push([x,y]);
        if (this.Series[0].length>this.MaxPointsCount) this.Series[0].splice(0,1);
      }
      
      AutoScrollingLineChart.prototype.AddData = function(x,y) {
        this.AddNoDrawData(x,y);
        this.UpdateChart();
      }
      
      AutoScrollingLineChart.prototype.Add2Data = function(x,y,y2) {
        this.Series[0].push([x,y]);
        if (this.Series[0].length>this.MaxPointsCount) this.Series[0].splice(0,1);
        if (this.Series.length<2) this.Series.push([]);
        this.Series[1].push([x,y2]);
        if (this.Series[1].length>this.MaxPointsCount) this.Series[1].splice(0,1);
        this.UpdateChart();
      }
      
      AutoScrollingLineChart.prototype.AddNoDrawSeriesData=function(SeriesID,x,y) {
        if (SeriesID>=0 && SeriesID<this.Series.length) {
          this.Series[SeriesID].push([x,y]);
          if (this.Series[SeriesID].length>this.MaxPointsCount) this.Series[SeriesID].splice(0,1);
        }
      }
      
      AutoScrollingLineChart.prototype.AddSeriesData=function(SeriesID,x,y) {
        AddNoDrawSeriesData(SeriesID,x,y);
        this.UpdateChart();
      }
      
      AutoScrollingLineChart.prototype.UpdateChart=function() {
        var DoRedraw=false;
      
        if (this.AutoScroll) {
          var RawXMax=this.Series[0][this.Series[0].length-1][0];
          
          for (i=1;i<this.Series.length;i++) {
            if (this.Series[i].length>0) {
              if (this.Series[i][this.Series[i].length-1][0]>RawXMax){ RawXMax=this.Series[i][this.Series[i].length-1][0]; }
            }
          }
          
          if (RawXMax>this.XMax) {
            this.XMax=Math.round((this.XMax+this.XScaleAutoScrollSize-10)/this.XScaleRound)*this.XScaleRound;
          }
        }
      
//      if (WindSpeedData.length>0) {
        this.UpdateScale();
        if (this.Chart) { // && (this.ChartOptions.axes.xaxis.min != this.XMax-this.XScale || this.ChartOptions.axes.xaxis.max != this.XMax)) {
          this.Chart.destroy(); // Force redraw
          DoRedraw=true;
        }
        this.ChartOptions.axes.xaxis.min = this.XMax-this.XScale;
        this.ChartOptions.axes.xaxis.max = this.XMax;
//        if (maxy>ChartOptions.axes.yaxis.max) {
//          ChartOptions.axes.yaxis.max=maxy;
//        }
        if (this.Chart && !DoRedraw) {
          this.Chart.drawSeries(this.ChartOptions,0);
        } else {
          this.Chart = $.jqplot (this.DivIDName, this.Series,this.ChartOptions);
        }
//      }
      }

    AutoScrollingLineChart.prototype.SetAutoScroll=function()
    {
      this.AutoScroll=true;
      this.XMax=(new Date()).getTime();
      this.UpdateChart();
    }
    
    AutoScrollingLineChart.prototype.MoveLeft=function()
    {
      this.MoveTime(-this.SmallMove);
    }
    
    AutoScrollingLineChart.prototype.MoveRight=function()
    {
      this.MoveTime(this.SmallMove);
    }
    
    AutoScrollingLineChart.prototype.MoveTime=function(moveSize)
    {
      this.AutoScroll=false;
      this.XMax=this.XMax+moveSize;
      this.UpdateChart();
    }
    
    AutoScrollingLineChart.prototype.ZoomMinus=function()
    {
      this.ZoomChange(-0.25);
    }
    
    AutoScrollingLineChart.prototype.ZoomPlus=function()
    {
      this.ZoomChange(0.25);
    }

    AutoScrollingLineChart.prototype.ZoomChange=function(f)
    {
      this.ZoomFactor=this.ZoomFactor+f;
      this.UpdateChart();
    }

    AutoScrollingLineChart.prototype.UpdateScale=function()
    {
      if (this.ZoomFactor>this.MaxZoom) this.ZoomFactor=this.MaxZoom;
      this.XScale=this.DefXScale/this.ZoomFactor;
      this.SmallMove=this.DefSmallMove/this.ZoomFactor;
    }

    AutoScrollingLineChart.prototype.ClearData=function()
    {
      for (i=0;i<this.Series.length;i++) { this.Series[i].length=0; }
    }
 
    